var Searge = {};

if (Client.getVersion().startsWith('1.12.')) {
  Searge.fields = JSON.parse(FileLib.read('SeargeHelper', 'mappings/1.12.2/fields.json'));
  Searge.methods = JSON.parse(FileLib.read('SeargeHelper', 'mappings/1.12.2/methods.json'));
} else {
  Searge.fields = JSON.parse(FileLib.read('SeargeHelper', 'mappings/1.8.9/fields.json'));
  Searge.methods = JSON.parse(FileLib.read('SeargeHelper', 'mappings/1.8.9/methods.json'));
}

Searge.method = function(obj, methodName) {
  // Dev environment compatibility
  if (!!obj[methodName]) 
    return methodName;

  var obfMappings = Searge.methods[methodName];

  if (!obfMappings || obfMappings.length === 0) 
    throw new Error('Cannot find any obfuscated method with real name ' + methodName);
    
  var mapping = obfMappings.find(function(obf) {
    return !!obj[obf];
  });
  
  if (!mapping)
    throw new Error('Cannot find method name ' + methodName + ' on object of type ' + obj.getClassName());

  return mapping;
};

Searge.field = function(obj, fieldName) {
  // Dev environment compatibility
  if (!!obj[fieldName]) 
    return fieldName;

  var obfMappings = Searge.fields[fieldName];

  if (!obfMappings || obfMappings.length === 0)
    throw new Error('Cannot find any obfuscated field with real name ' + fieldName);

  var mapping = obfMappings.find(function(obf) {
    return !!obj[obf];
  });

  if (!mapping)
    throw new Error('Cannot find field name ' + fieldName + ' on object of type ' + obj.toString());

  return mapping;
};

Searge.is1122 = function(str) {
  str = str.toLowerCase().trim();
  return str === '1122' || str === '1.12.2' || str === '1.12';
}